part of tecfy_corev2_client_package;

abstract class ITranslateService {
  Map<String, dynamic> getJson(Language language);
}

class AppLocale {
  AppLocale(this.locale);

  // ignore: close_sinks
  static StreamController<Language>? _languageStreamController;
  static StreamController<Language> get languageStreamController {
    if (_languageStreamController == null) {
      _languageStreamController = StreamController<Language>();
    }
    return _languageStreamController ?? StreamController<Language>();
  }

  static Stream<Language>? _languageStream;
  static Stream<Language> get languageStream {
    if (_languageStreamController == null) {
      _languageStreamController = StreamController<Language>();
    }
    if (_languageStream == null) {
      _languageStream = _languageStreamController?.stream.asBroadcastStream();
    }
    return _languageStream ??
        languageStreamController.stream.asBroadcastStream();
  }

  final Locale? locale;
  static AppLocale? appLocale;
  static AppLocale? of(BuildContext? context) {
    if (appLocale != null) return appLocale;
    if (context == null) {
      if (kDebugMode) print('+++++++++++++++ NULLLLLLLLLLLLLL');
      return new AppLocale(null);
    }
    var result = Localizations.of<AppLocale>(context, AppLocale);
    if (result == null) if (kDebugMode)
      print('+++++++++++++++++ class is null');
    else
      appLocale = result;
    return result;
  }

  static Map<String, dynamic>? _sentences;

  Future<bool> load() async {
    //from file
    //String data = await rootBundle.loadString('resources/lang/${this.locale.languageCode}.json');
    //from databse
    //print('================== Start Loading the language (${LocalConfigService.language})  isArabic = ${LocalConfigService.isArabic}');
    // Firestore.instance.document('languages/${this.locale.languageCode}/translation/default').snapshots().listen((onData){
    //   this._sentences = onData.data;
    await ConfigService.init();
    _sentences = LocalConfigService.isArabic
        ? {
            'Save New': 'حفظ جديد',
            'Main Page': 'الشاشة الرئيسية',
            'Reports': 'التقارير',
            'Account Settings': 'بيانات الحساب',
            'Welcome': 'مرحباً بك',
            'Settings': 'الاعدادات',
            'Logout': 'تسجيل خروج',
            'Loading': 'جاري التحميل',
            'Filter': 'تصفيه',
            'Details': 'تفاصيل',
            'OK': 'موافق',
            'Add Row': 'اضافه جديد',
            'Contain': 'يحتوي',
            'Not Contain': 'لا يحتوي',
            'Email or Username': 'اسم المستخدم او البريد الاكتروني',
            'Password': 'كلمه المرور',
            'LOG IN': 'تسجيل دخول',
            'Unlock': 'دخول',
            'Lock': 'قفل البرنامج',
            'OR': 'او',
            'Contact Us': 'تواصل معنا',
            'Website': 'الموقع الاكتروني',
            'Add': 'اضافه',
            'Refresh': 'تحديث',
            'Next Page': 'التالي',
            'Language': 'اللغه',
            'Please wait': 'جاري التحميل',
            'Action': 'الاجراء',
            'Edit': 'تعديل',
            'Delete': 'حذف',
            'Search': 'بحث',
            'Chat With': 'محادثه مع',
            'Connection': 'الاتصال',
            'Connection Status': 'حاله الاتصال',
            'Status': 'الحالة',
            'Description': 'الوصف',
            'Type a new message': 'ادخل رساله جديدة',
            'Click to add new record': 'اضغط لاضافة سجل',
            'Click to add new': 'اضافة',
            'Are you sure you want to logout?':
                'هل تريد تسجيل الخروج من البرنامج؟',
            'Add New Item': 'اضافه سجل جديد',
            'Count': 'العدد',
            'Unposted Items': 'سجلات غير مصدره',
            'Enable Expert Mode': 'تفعيل النظام الاحترافي',
            'Merge': 'دمج',
            'Merge Field': 'الحقل المستخدم للدمج',
            'Merge Data': 'بيانات الدمج',
            'History': 'سجل الاحداث',
            'New Version Available': 'يوجد اصدار جديد من البرنامج',
            'Please Refresh The Web Page': 'الرجاء تحديث الصفحة',
            'Please Click here to Update': 'اضغط هنا لتحميل النسخه الجديدة',
            'Text Value Required': 'لا يوجد قيمة',
            'Value Required': 'لا يوجد ادخال',
            'Add at least one record': 'يجب ادخال قيمه واحده على الاقل',
            'Max Length exceped': 'تم تخطي الحد المسموح',
            'Min Length not reached': 'القيمه المدخله اقل من المسموح',
            'Subcategory': 'التصنيف الفرعي',
            'Enable Development Mode': 'تفعيل نظام التطوير',
            'Lock Timeout': 'مدة قفل البرنامج',
            'Never': 'أبداً',
            'Export': 'تصدير',
            'KafaratPlus balance for the provider': 'رصيد كفرات بلس للمزود',
            'Pay an amount to the provider': 'دفع مبلغ لمقدم الخدمة',
            'Collecting an amount from the provider': 'تحصيل مبلغ من المزود',
            'Note': 'ملاحظات',
            'Download File': 'تحميل الملف',
            'File': 'الملف',
            'Download': 'تحميل',
            'Save': 'حفظ',
            'photos were selected': 'تم اختيار الصور'
          }
        : {};

    var customLang =
        TecfyCoreApp.translateService?.getJson(LocalConfigService.language);
    if (customLang != null) _sentences?.addAll(customLang);
    // });
    //var language = await Firestore.instance.document('languages/ar').get();
    //print('================== got some data');
    //print(language.data);
    //print(language.data['Driver']);
    //this._sentences = language.data;
    //print(this._sentences.keys.length);
    return true;

    // var language = await Firestore.instance.document('languages/default').get();
    // String data = language.data[this.locale.languageCode].toString();

    // this._sentences = json.decode(data);
    // return true;
  }

  static String translate(String? key) {
    if (TecfyBasicApp.isTest) return key ?? '';
    if (_sentences == null || key == null) return key ?? '[NULL]';
    return _sentences![key] ?? key;
  }

  String trans(String? key) {
    //print('+++++++++++++++ get lang $key');
    if (key == null) return '';
    try {
      if (_sentences == null) {
        print('_sentences is null');
        return key;
      }
      return (_sentences?.containsKey(key) ?? false)
          ? (_sentences?[key] ?? key)
          : key;
    } catch (ex) {
      print('trans error : $ex');
      return key;
    }
  }
}
